<!--
@license
Copyright (c) 2015 Vaadin Ltd.
This program is available under Apache License Version 2.0, available at https://vaadin.com/license/
-->

<link rel='import' href='../polymer/polymer.html'>
<script src="vaadin-grid.min.js"></script>

<style>
  vaadin-grid > table {
    display: none;
  }
</style>

<!--
High quality data grid for showing large amounts of tabular data.

Simple usage (static HTML data source):
```html
<vaadin-grid>
  <table>
    <colgroup>
      <col name="firstName">
      <col name="lastName">
      <col name="email">
    </colgroup>
    <thead>
      <tr>
        <th>Name</th>
        <th>Value</th>
        <th>Progress</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td>Jonathan</td>
        <td>Doe</td>
        <td>jonathan.doe@example.com</td>
      </tr>
      <tr>
        <td>Jane</td>
        <td>Smith</td>
        <td>jane.smith@example.com</td>
      </tr>
    </tbody>
  </table>
</vaadin-grid>
```

### Styling

The grid uses `--default-primary-color` from [paper-styles](https://github.com/PolymerElements/paper-styles) as a highlight color. You can customize the color by defining your own primary default color.

```html
<style is="custom-style">
  vaadin-grid {
    --default-primary-color: red;
  }
</style>
```
The following custom properties are available for styling:

Custom property | Description | Default
:----------------|:-------------|----------:
`--vaadin-grid-row-height` | Data row height | `48px`
`--vaadin-grid-header-row-height` | Header row height | `56px`
`--vaadin-grid-footer-row-height` | Footer row height | `56px`

See the [demo](demo/index.html) for use case examples.

@element vaadin-grid
@demo demo/index.html
-->
<dom-module id="vaadin-grid">
  <style>
  /* fix chrome bug */
  .vaadin-grid-body .vaadin-grid-spacer td {
    opacity: 1;
    display: block;
    padding: 0;
  }

 /* Host styles */
  :host {
    -webkit-tap-highlight-color: transparent;
    -webkit-touch-callout: none;
    box-sizing: border-box;
    font-family: inherit;
    font-size: 13px;
    font-weight: 400;
    line-height: 1.1;
    color: rgba(0, 0, 0, 0.87);
    cursor: default;
    transition: opacity 50ms;
    white-space: nowrap;
    position: relative;
    display: -webkit-flex;
    display: flex;
    -webkit-flex-direction: column;
    flex-direction: column;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
  }

  :host(.vaadin-grid-loading) {
    height: 0;
    opacity: 0;
    transition: none;
  }

  :host > div {
    height: 100%;
    outline: none;
    position: relative;
    z-index: 0;
    -webkit-flex: 1 1 auto;
    flex: 1 1 auto;
  }

  /* Anim */
  @keyframes vaadin-grid-spin-360 {
    100% {
      transform: rotate(360deg);
    }
  }

  @-webkit-keyframes vaadin-grid-spin-360 {
    100% {
      -webkit-transform: rotate(360deg);
      transform: rotate(360deg);
    }
  }

  /* Table wrapper */
  .vaadin-grid-tablewrapper {
    box-sizing: border-box;
    overflow: hidden;
    outline: none;
    position: absolute;
    z-index: 5;
  }

  .vaadin-grid-tablewrapper:before {
    display: none;
  }

  .vaadin-grid-tablewrapper > table {
    box-sizing: border-box;
    display: block;
  }

  .vaadin-grid-loading-data .vaadin-grid-tablewrapper:before {
    -webkit-animation: vaadin-grid-spin-360 400ms linear infinite;
    animation: vaadin-grid-spin-360 400ms linear infinite;
    border: 2px solid #03A9F4;
    border-radius: 50%;
    border-right-color: transparent;
    border-top-color: transparent;
    content: "";
    display: block;
    height: 16px;
    left: 50%;
    margin-left: -8px;
    margin-top: -8px;
    position: absolute;
    top: 50%;
    width: 16px;
  }

  /* Scroller styles */
  .vaadin-grid-scroller {
    box-sizing: border-box;
    outline: none;
    position: absolute;
    z-index: 1;
  }

  .vaadin-grid-scroller-horizontal {
    bottom: 0;
    left: 0;
    right: 0;
    overflow-y: hidden;
    -ms-overflow-y: hidden;
  }

  .vaadin-grid-scroller-vertical {
    bottom: 0;
    right: 0;
    top: 0;
    overflow-x: hidden;
    -ms-overflow-x: hidden;
  }

  .vaadin-grid-horizontal-scrollbar-deco {
    bottom: 0;
    box-sizing: border-box;
    left: 0;
    position: absolute;
    right: 0;
  }

  /* Grid body */
  .vaadin-grid-body {
    box-sizing: border-box;
    display: block;
    left: 0;
    position: absolute;
    top: 0;
    z-index: 0;
  }

  :host(:not([selection-mode])) .vaadin-grid-body,
  :host([selection-mode="single"]) .vaadin-grid-body {
    cursor: pointer;
  }

  .vaadin-grid-body tr {
    height: var(--vaadin-grid-row-height, 48px);
    left: 0;
    top: 0;
    position: absolute;
  }

  :host ::content .vaadin-grid-spacer {
    position: absolute;
    border-bottom: 1px solid #e3e3e3;
    z-index: 1;
  }

  :host ::content .vaadin-grid-spacer > td {
      position: absolute;
      padding: 0;
      top: 0;
      left: 0;
      width: 100%;
  }

  .vaadin-grid-body td {
    opacity: 0;
  }

  .vaadin-grid-row-has-data td {
    border-bottom: 1px solid #e3e3e3;
    opacity: 1;
  }

  /* Row styles */
  .vaadin-grid-row {
    box-sizing: border-box;
    display: block;
  }

  tbody:not(.touch):not(.scrolling) .vaadin-grid-row:hover td {
    background-color: #eeeeee;
  }

  .vaadin-grid-row-selected td {
    background-color: #f5f5f5;
  }

   /* Focus styles */
  .vaadin-grid-row:after {
    background-color: var(--default-primary-color, #03A9F4);
    bottom: 0;
    content: "";
    height: 2px;
    left: 0;
    pointer-events: none;
    position: absolute;
    right: 0;
    transition: all 0.16s ease-in-out;
    -webkit-transform: scaleX(0.0);
    transform: scaleX(0.0);
    z-index: 1;
  }

  :focus .vaadin-grid-row-focused:after {
    -webkit-transform: scaleX(1.0);
    transform: scaleX(1.0);
  }

  :focus .vaadin-grid-row-focused {
    -webkit-animation: v-grid-row-focused 820ms ease-in-out;
    animation: v-grid-row-focused 820ms ease-in-out;
  }

  @-webkit-keyframes vaadin-grid-row-focused {
    50% {
      color: #03A9F4;
    } 100% {
      color: inherit;
    }
  }

  @keyframes vaadin-grid-row-focused {
    50% {
      color: #03A9F4;
    } 100% {
      color: inherit;
    }
  }

  /* Grid cell */
  .vaadin-grid-cell {
    -webkit-align-items: center;
    align-items: center;
    background-color: white;
    box-sizing: border-box;
    display: -webkit-inline-flex;
    display: inline-flex;
    height: inherit;
    overflow: hidden;
    transition: opacity 0.1s ease-in;
  }

  /* Grid header */
  .vaadin-grid-header {
    box-shadow: 0 1px 0 rgba(0, 0, 0, 0.06),
                0 2px 0 rgba(0, 0, 0, 0.075),
                0 3px 0 rgba(0, 0, 0, 0.05),
                0 4px 0 rgba(0, 0, 0, 0.015);
    box-sizing: border-box;
    display: block;
    left: 0;
    position: absolute;
    top: 0;
    z-index: 10;
    padding-right: 2px;
  }

  .vaadin-grid-header tr {
    color: rgba(0, 0, 0, 0.54);
    font-size: 12px;
    height: var(--vaadin-grid-header-row-height, 56px);
  }

  .vaadin-grid-header th {
    font-weight: 500;
    text-align: left;
  }

  .vaadin-grid-header-deco {
    background-color: white;
    border-left: 1px solid rgba(255, 255, 255, 0.3);
    box-sizing: border-box;
    position: absolute;
    right: 0;
    top: 0;
    z-index: 1;
  }

  /* Sorting */
  .vaadin-grid-header [class*="sort-"] {
    font-weight: 500;
    font-size: 12px;
    color: rgba(0, 0, 0, 0.87);
    position: relative;
  }

  .vaadin-grid-header [class*="sort-"]:after {
    font-size: 8px;
    padding-left: 8px;
    width: 1em;
    min-width: 12px;
    display: inline-block;
  }

  .vaadin-grid-header .sort-asc:after {
    content: url(img/arrow-up.svg) " " attr(sort-order);
  }

  .vaadin-grid-header .sort-desc:after {
    content: url(img/arrow-down.svg) " " attr(sort-order);
  }

  /* Grid footer */
  .vaadin-grid-footer {
    bottom: 0;
    box-sizing: border-box;
    display: block;
    left: 0;
    position: absolute;
    z-index: 10;
    box-shadow: 0 -1px 0 rgba(0, 0, 0, 0.2);
  }

  .vaadin-grid-footer td {
    font-size: 12px;
    font-weight: 500;
    color: rgba(0, 0, 0, 0.56);
    height: var(--vaadin-grid-footer-row-height, 56px);
  }

  .vaadin-grid-footer-deco {
    bottom: 0;
    box-sizing: border-box;
    position: absolute;
    right: 0;
    z-index: 1;
  }

  .vaadin-grid-spacer-deco-container {
    display: none;
  }

  /* Cell padding */
  .vaadin-grid-header th,
  .vaadin-grid-body td,
  .vaadin-grid-footer td {
       padding: 0 24px 0 24px;
  }

  .vaadin-grid-cell.last-frozen {
    border-right: 1px solid #e3e3e3;
  }

  .vaadin-grid-cell.frozen {
    position: relative;
    z-index: 1;
  }

  /* Input styles */
  input[type="checkbox"] {
    position: absolute;
    opacity: 0;
  }

  input[type="checkbox"] + label {
    position: relative;
    left: 0;
    box-sizing: border-box;
    display: block;
    width: 18px;
    height: 18px;
    border: 2px solid #7a7a7a;
    border-radius: 2px;
    cursor: pointer;
    transition: background-color 120ms, border-color 120ms;
  }

  input[type="checkbox"]:focus {
    outline: none;
  }

  input[type="checkbox"] + label:after {
    content: url(img/tick.svg);
    position: absolute;
    top: -1px;
    left: -1px;
    display: block;
    width: 16px;
    height: 17px;
    transition: all 200ms;
    -webkit-transform: scale(0);
    transform: scale(0);
    -webkit-transform-origin: 40% 80%;
    transform-origin: 40% 80%;
  }

  input[type="checkbox"]:checked + label {
    background-color: var(--default-primary-color, #03A9F4);
    border-color: transparent;
  }

  input[type="checkbox"]:checked + label:after {
    -webkit-transform: scale(1);
    transform: scale(1);
  }

  input[type="checkbox"]:indeterminate + label:after {
    content: "–";
    font-family: arial;
    font-weight: bold;
    font-size: 14px;
    line-height: 1;
    text-align: center;
    -webkit-transform: scale(1);
    transform: scale(1);
    transition: none;
  }

  /* Activation "splash" */
  input[type="checkbox"] + label:before {
    content: "";
    position: absolute;
    top: -13px;
    left: -13px;
    width: 41px;
    height: 41px;
    border-radius: 50%;
    background-color: #666;
    opacity: 0;
    -webkit-transform: scale(0.8);
    transform: scale(0.8);
    transition: all 180ms cubic-bezier(0.75,.0,0.25,1);
  }

  input[type="checkbox"] + label:active:before {
    transform: scale(1.1);
    opacity: 0.15;
    transition-duration: 80ms;
    transition-property: all;
  }

  input[type="checkbox"]:checked + label:before {
    background-color: var(--default-primary-color, #03A9F4);
  }

  #measureobject {
    width: 100% !important;
    height: 100%;
    z-index: -1 !important;
    pointer-events: none !important;
    position: absolute !important;
    left: -100% !important;
    opacity: 0 !important;
    /* This is used to force a non-zero client height to the measure object. */
    padding-bottom: 1px !important;
  }

  /* The following is a workaround to https://dev.vaadin.com/ticket/18376 */
  .vaadin-grid-scroller[invisible]::-webkit-scrollbar {
    border: none;
  }

  .vaadin-grid-scroller[invisible]::-webkit-scrollbar-thumb {
    border-radius: 10px;
    border: 4px solid transparent;
    background: rgba(0,0,0,.3);
    -webkit-background-clip: content-box;
    background-clip: content-box;
  }


  .vaadin-grid-scroller-vertical[invisible]::-webkit-scrollbar-thumb {
    min-height: 30px;
  }

  .vaadin-grid-scroller-horizontal[invisible]::-webkit-scrollbar-thumb {
    min-width: 30px;
  }


  .vaadin-grid-sidebar {
    z-index: 5;
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    pointer-events: none;
  }

  .vaadin-grid-sidebar-button {
    width: 56px;
    height: 56px;
    border: none;
    background: none;
    outline: none;
    position: relative;
    cursor: pointer;
    pointer-events: all;
  }

  .vaadin-grid-sidebar-button::before {
    content: "";
    position: absolute;
    left: 12px;
    top: 10px;
    width: 32px;
    height: 32px;
    border-radius: 50%;
    background: #fff;
    box-shadow: 0 0 10px 4px #fff;
  }

  .vaadin-grid-sidebar-button:after {
    content: url(img/ic_view_column_black_24px.svg);
    display: inline-block;
    position:absolute;
    top: 14px;
    left: 16px;
    width: 24px;
  }

  .vaadin-grid-sidebar-content {
    background-color: #ffffff;
    position: absolute;
    right: 0;
    top: 44px;
    box-shadow: 0 2px 2px 0 rgba(0,0,0,.14),0 3px 1px -2px rgba(0,0,0,.2),0 1px 6px 0 rgba(0,0,0,.12);
    border-radius: 2px;
    max-height: calc(100% - 56px);
    pointer-events: all;
    overflow-y: auto;
    -webkit-animation: vaadin-grid-sidebar-transition 0.2s ease-in;
    animation: vaadin-grid-sidebar-transition 0.2s ease-in;
  }

  @keyframes vaadin-grid-sidebar-transition {
    0% {
      opacity: 0;
      top: 48px;
    }
    100% {
      opacity: 1;
      top: 44px;
    }
  }

  @-webkit-keyframes vaadin-grid-sidebar-transition {
    0% {
      opacity: 0;
      top: 48px;
    }
    100% {
      opacity: 1;
      top: 44px;
    }
  }

  .vaadin-grid-sidebar-content::content > div {
    padding: 6px 0;
  }

  .vaadin-grid-sidebar-content::content span:before {
    content: url(img/ic_check_black_24px.svg);
    display: inline-block;
    padding: 0 20px;
  }

  .vaadin-grid-sidebar-content::content .v-off:before {
    visibility: hidden;
  }

  .vaadin-grid-sidebar-content::content span div {
    display: inline-block;
    vertical-align: super;
    padding-right: 20px;
  }

  .vaadin-grid-sidebar-content::content table {
    border-collapse: collapse;
  }

  .vaadin-grid-sidebar-content::content .column-hiding-toggle {
    cursor: pointer;
  }

  .vaadin-grid-sidebar-content::content .gwt-MenuItem-selected {
    background: #eeeeee;
  }

  .vaadin-grid-sidebar.closed:after {
    content: "Show/hide columns";
    z-index: 999;
    background: rgba(97,97,97,.9);
    border-radius: 2px;
    color: #fff;
    display: inline-block;
    font-size: 10px;
    font-weight: 500;
    line-height: 14px;
    padding: 8px;
    text-align: center;
    position: absolute;
    right: 0;
    top: 44px;
    opacity: 0;
    transition: opacity 0.1s ease-in;
  }

  .vaadin-grid-sidebar.closed:hover:after {
    opacity: 1;
  }
  </style>
  <template>
    <iframe id="measureobject" class="vaadin-grid"></iframe>
  </template>
</dom-module>

<script>
  function gridLoaded() {
    return window.vaadin && vaadin.elements && vaadin.elements.grid && vaadin.elements.grid.GridElement;
  }
  if (!gridLoaded()) {
    // This is needed when vaadin-grid.min.js is loaded asynchronously like
    // in SDM. We must guarantee that gwt grid is loaded and exported before
    // Polymer is called.
    var _Polymer = Polymer;
    // Override Polymer
    Polymer = function(obj) {
      // Restore Polymer
      Polymer = _Polymer;
      var _done = false;
      // Overwrite whenReady
      var _whenReady = HTMLImports.whenReady;
      HTMLImports.whenReady = function(done) {
        var id = setInterval(function() {
          if (gridLoaded()) {
            clearInterval(id);
            if (!_done) {
              // Run original Polymer
              _Polymer(obj);
              _done = true;
            }
            // Restore whenReady
            HTMLImports.whenReady = _whenReady;
            // Run original whenReady
            _whenReady(done);
          }
        }, 3);
      };
    };
  }

  Polymer({

    is: "vaadin-grid",

    _grid: undefined,

    properties: {

      /**
       * Object for controlling and accessing the header rows in the grid.
       *
       * See the API documentation for “header” for more details.
       *
       * @property {header} footer
       * @type {header}
       */
      header: {
        type: Object,
        readOnly: true,
        value: function() {
          var _this = this;
          return {
            getCell: function(rowIndex, columnId) {
              return _this._grid.getStaticSection().getHeaderCell(rowIndex, columnId);
            },
            addRow: function(rowIndex, cellContent) {
              _this._grid.getStaticSection().addHeader(rowIndex, cellContent);
            },
            removeRow: function(rowIndex) {
              _this._grid.getStaticSection().removeHeader(rowIndex);
            },
            setRowClassName: function(rowIndex, className) {
              _this._grid.getStaticSection().setHeaderRowClassName(rowIndex, className);
            },
            get defaultRow() {
              return _this._grid.getStaticSection().getDefaultHeader();
            },
            set defaultRow(rowIndex) {
              _this._grid.getStaticSection().setDefaultHeader(rowIndex);
            },
            get hidden() {
              return _this._grid.getStaticSection().isHeaderHidden();
            },
            set hidden(hidden) {
              _this._grid.getStaticSection().setHeaderHidden(hidden);
            },
            get rowCount() {
              return _this._grid.getStaticSection().getHeaderRowCount();
            }
          };
        }
      },

      /**
       * Object for controlling and accessing the footer rows in the grid.
       *
       * See the API documentation for “footer” for more details.
       *
       * @property {footer} footer
       * @type {footer}
       */
      footer: {
        type: Object,
        readOnly: true,
        value: function() {
          var _this = this;
          return {
            getCell: function(rowIndex, columnId) {
              return _this._grid.getStaticSection().getFooterCell(rowIndex, columnId);
            },
            addRow: function(rowIndex, cellContent) {
              _this._grid.getStaticSection().addFooter(rowIndex, cellContent);
            },
            removeRow: function(rowIndex) {
              _this._grid.getStaticSection().removeFooter(rowIndex);
            },
            setRowClassName: function(rowIndex, className) {
              _this._grid.getStaticSection().setFooterRowClassName(rowIndex, className);
            },
            get hidden() {
              return _this._grid.getStaticSection().isFooterHidden();
            },
            set hidden(hidden) {
              _this._grid.getStaticSection().setFooterHidden(hidden);
            },
            get rowCount() {
              return _this._grid.getStaticSection().getFooterRowCount();
            }
          };
        }
      },

      /**
       * An array or a function containing or returning items determining
       * the row data in the grid (i.e. the data source).
       *
       * Implement the property as a function if you wish to provide data
       * lazily to the grid, for example from a REST service, to get only the
       * items that are necessary in the grid viewport.
       *
       * See the API documentation for "items function" for more details.
       *
       * For an in-memory list of items, use the `items` array property instead.
       *
       * In both options, at the end the grid expects to receive an array, which
       * can contain either arrays, objects or primitive types.
       *
       * #### Examples:
       *  ```
       *  grid.items = [
       *      {
       *        firsName: "Jonathan",
       *        lastName: "Doe",
       *        email: "jonathan.doe@example.com"
       *      },
       *      {
       *        firstName: "Jane",
       *        lastName: "Smith",
       *        email: "jane.smith@example.com"
       *      }
       *  ];
       *  ```
       *  ```
       *  grid.items = function(params, callback) {
       *    callback(["foo", "bar"], 2);
       *  };
       *  ```
       *
       * @property {(Array<Object>|function)} items
       * @type {(Array<Object>|function)}
       */
      items: {
        type: Object,
        observer: '_itemsChanged'
      },

      /**
       * Object for controlling and accessing the selected rows in the grid.
       *
       * See the API documentation for the “selection” object for more details.
       *
       * @property {selection} selection
       * @type {selection}
       * @default {}
       */
      selection: {
        type: Object,
        readOnly: true,
        value: function() {
          var _this = this;
          return {
            select: function(index) {
              _this._grid.getSelectionModel().select(index);

              return _this;
            },
            deselect: function(index) {
              _this._grid.getSelectionModel().deselect(index);

              return _this;
            },
            clear: function() {
              _this._grid.getSelectionModel().clear();

              return _this;
            },
            selectAll: function() {
              _this._grid.getSelectionModel().selectAll();

              return _this;
            },
            selected: function(mapper, from, to) {
              return _this._grid.getSelectionModel().selected(mapper, from, to);
            },
            deselected: function(mapper, from, to) {
              return _this._grid.getSelectionModel().deselected(mapper, from, to);
            },
            get size() {
              return _this._grid.getSelectionModel().size();
            },
            get mode() {
              return _this._grid.getSelectionMode();
            },
            set mode(mode) {
              _this._grid.setSelectionMode(mode);
            }
          };
        }
      },

      /**
       * An array defining the sorting of columns. The order of the objects in
       * the array defines the order of sort (if the grid is sorted by
       * multiple columns).
       *
       * See the API documentation for the “sort-order” object for more details.
       *
       * @property {Array<sort-order>}
       * @type {Array<sort-order>}
       */
      sortOrder: {
        type: Array,
        notify: true,
        observer: '_sortOrderChanged'
      },

      /**
       * Explicitly sets the number of records the `items` array/function
       * provides for the grid to display.
       *
       * This may also be set indirectly by passing the value as the second
       * parameter for data request callback function.
       *
       * @property {Number} size
       * @type {Number}
       */
      size: {
        type: Number,
        observer: '_sizeChanged'
      }
    },

    attributeChanged: function(name, type, value) {
      switch (name) {
        case 'disabled':
          var disabled = typeof value == "string";
          if (this.disabled != disabled) {
            this.disabled = disabled;
          }
          break;
        case 'selection-mode':
          if (this.selection.mode != value) {
            this.selection.mode = value;
          }
          break;
        default:
          var property = Polymer.CaseMap.dashToCamelCase(name);
          if (this[property] != value) {
            this[property] = value;
          }
      }
    },

    listeners: {
      /**
       * A change in the sorting order.
       *
       * @event sort-order-changed
       */

      /**
       * A row is selected or deselected.
       *
       * @event selected-items-changed
       */

      /**
       * A change in the selection mode.
       *
       * @event selection-mode-changed
       */
      'selection-mode-changed': '_onSelectionModeChange'
    },

    _itemsChanged: function(items) {
      if (Array.isArray(items)) {
        this._grid.setDataSource(function(params, callback) {
          var array = items.slice(params.index, params.index + params.count);
          callback(array);
        });
        this.size = items.length;
        this.refreshItems();
      } else if (typeof items === 'function') {
        this._grid.setDataSource(items);
      } else {
        throw new Error('Unknown items type: ' + items + '. Only arrays and functions are supported.');
      }
    },

    _sizeChanged: function(size, oldSize) {
      this._grid.sizeChanged(size, oldSize);
    },

    _onSelectionModeChange: function() {
      this.serializeValueToAttribute(this.selection.mode, "selection-mode");
    },

    _sortOrderChanged: function(sortOrder) {
      this._grid.setSortOrder(sortOrder);
    },

    created: function() {
      this._grid = new vaadin.elements.grid.GridElement();
    },

    ready: function() {
      // hide until fully loaded
      this.toggleClass('vaadin-grid-loading', true);
      this.async(function() {
        for (var i = 0; i < this.attributes.length; i++) {
          this.attributeChanged(this.attributes[i].nodeName, null, this.attributes[i].nodeValue);
        }
      });
      this._grid.init(this, this._findTableElement(Polymer.dom(this).children), Polymer.dom(this.root), this.$.measureobject);
    },

    _findTableElement: function(nodes) {
      for (var i = 0; i < nodes.length; i++) {
        if (nodes[i].nodeName === 'TABLE') {
          return nodes[i];
        } else if (nodes[i].nodeName === 'CONTENT') {
          var contentNodes = Polymer.dom(nodes[i]).getDistributedNodes();
          return this._findTableElement(contentNodes);
        }
      }
    },

    _bindResizeListener: function() {
      var _this = this;
      this.$.measureobject.addEventListener("load", function() {
        var defaultView = this.contentDocument.defaultView;
        var prevW = -1;
        var prevH = -1;
        defaultView.addEventListener('resize', function(e) {
          var newW = defaultView.innerWidth;
          var newH = defaultView.innerHeight;
          if (newW != prevW || newH != prevH) {
            prevW = newW;
            prevH = newH;
            _this._grid.updateSize();
          }
        }.bind(this));
        _this._grid.updateSize();
      });

      this.$.measureobject.src = "about:blank";
    },

    attached: function() {
      var _this = this;
      this._bindResizeListener();
      this.then(function() {
        _this.toggleClass('vaadin-grid-loading', false);
      });
    },

    /**
     * Scrolls to a certain row, using user-specified scroll destination.
     *
     * Scrolling happens asynchronously, so this method returns a 'thenable'
     * which can be used to be notified when the scrolling is finished.
     *
     * #### Example:
     * ```js
     * grid.scrollToRow(10, "end").then(function() {...});
     * ```
     *
     * @param {number} index - Zero-based index of the row to scroll to.
     * @param {string} scrollDestination - Desired destination placement of scrolled-to-row. Valid values are `any`, `start`, `middle` and `end`. Defaults to `any`.
     * @return {vaadin-grid}
     */
    scrollToRow: function(index, scrollDestination) {
      this._grid.scrollToRow(index, scrollDestination);
      return this;
    },

    /**
     * Scrolls to the beginning of the grid.
     *
     * Scrolling happens asynchronously, so this method returns a 'thenable'
     * which can be used to be notified when the scrolling is finished.
     *
     * #### Example:
     * ```js
     * grid.scrollToStart().then(function() {...});
     * ```
     *
     * @return {vaadin-grid}
     */
    scrollToStart: function() {
      this._grid.scrollToStart();
      return this;
    },

    /**
     * Scrolls to the end of the grid.
     *
     * Scrolling happens asynchronously, so this method returns a 'thenable'
     * which can be used to be notified when the scrolling is finished.
     *
     * #### Example:
     * ```js
     * grid.scrollToEnd().then(function() {...});
     * ```
     *
     * @return {vaadin-grid}
     */
    scrollToEnd: function() {
      this._grid.scrollToEnd();
      return this;
    },

    /**
     * Adds a new column. Column is added at the end if `beforeColumn` is not defined.
     *
     * @param {column} column - Column object to be added.
     * @param {string} beforeColumn - Index or id of the column before which the new column should be added.
     */
    addColumn: function(column, beforeColumn) {
      this._grid.addColumn(column, beforeColumn);
    },

    /**
     * Removes a column with certain id
     *
     * @method removeColumn
     * @param {string} id - Column to be removed.
     */
    removeColumn: function(id) {
      this._grid.removeColumn(id);
    },

    /**
     * @private
     */
    get rowClassGenerator() {
      return this._grid.getRowClassGenerator();
    },

    /**
     * A function which is used for generating CSS class names for data rows.
     *
     * See the API documentation for the “row” object for more details about
     * the parameter of this function.
     *
     * #### Example:
     * ```js
     * grid.rowClassGenerator = function(row) {
     *   var activity = row.data[2];
     *   return "activity-" + activity.toLowerCase();
     * };
     *```
     *
     * @property {function} rowClassGenerator
     * @type {function}
     */
    set rowClassGenerator(row) {
      this._grid.setRowClassGenerator(row);
    },

    /**
     * @private
     */
    get cellClassGenerator() {
      return this._grid.getCellClassGenerator();
    },

    /**
     * A function which is used for generating CSS class names for data cells.
     *
     * See the API documentation for the “cell” object for more details about
     * the parameter of this function.
     *
     * #### Example:
     * ```js
     * grid.cellClassGenerator = function(cell) {
     *   if (cell.index == 2) {
     *      return "activity-" + cell.data.toLowerCase();
     *    }
     *  };
     * ```
     * @property {function} cellClassGenerator
     * @type {function}
     */
    set cellClassGenerator(cell) {
      this._grid.setCellClassGenerator(cell);
    },

    /**
     * Disables the grid.
     *
     * #### Declarative example:
     * ```html
     * <vaadin-grid disabled>...</vaadin-grid>
     * ```
     *
     * @default false
     * @type {boolean}
     */
    get disabled() {
      return this._grid.isDisabled();
    },
    /**
     * @private
     */
    set disabled(disabled) {
      this._grid.setDisabled(disabled);
      this.reflectPropertyToAttribute("disabled");
    },

    /**
     * The index of the last frozen columns in this grid. A frozen column will
     * always stay visible in the grid viewport when the user scrolls the grid
     * viewport horizontally.
     *
     * Setting the property to 0 means that no columns will be frozen,
     * but the built-in selection checkbox column will still be frozen if
     * it’s in use. Setting the count to -1 will unfreeze the selection
     * column also.
     *
     * #### Declarative example:
     * ```html
     * <vaadin-grid frozen-columns="2">...</vaadin-grid>
     * ```
     *
     * @default 0
     * @type {number}
     */
    get frozenColumns() {
      return this._grid.getFrozenColumns();
    },
    /**
     * @private
     */
    set frozenColumns(frozenColumns) {
      this._grid.setFrozenColumns(frozenColumns);
      this.reflectPropertyToAttribute("frozenColumns");
    },

    /**
     * Sets the height of the grid so that the specified amount of data rows
     * is visible. Overrides any height specified in CSS.
     *
     * #### Declarative example:
     * ```html
     * <vaadin-grid rows="5">...</vaadin-grid>
     * ```
     *
     * @property {number} visibleRows
     * @default 10
     * @type {number}
     */
    get visibleRows() {
      var rows = this._grid.getVisibleRows();
      return rows > 0 ? rows : undefined;
    },

    /**
     * @private
     */
    set visibleRows(visibleRows) {
      this._grid.setVisibleRows(visibleRows);
      this.reflectPropertyToAttribute("visibleRows");
    },

    /**
     * The array of columns attached to the grid.
     *
     * See the API documentation for “column” for more details about the
     * column objects.
     *
     * @property {Array<object>} columns
     * @type {Array<object>}
     */
    get columns() {
      return this._grid.getColumns();
    },
    /**
     * @private
     */
    set columns(cols) {
      this._grid.setColumns(cols);
    },

    /**
     * Executes a callback when the grid has finished any pending work.
     *
     * @method then
     * @param {Function} callback
     * @return {Promise}
     */
    then: function(callback) {
      return this._grid.then(callback);
    },

    /**
     * The row details generator is used for generating detail content for
     * data rows. The details element is added directly under the row.
     *
     * #### Example:
     * ```js
     * grid.rowDetails.detailsGenerator = function(rowIndex) {
     *   var detail = document.createElement("div");
     *   detail.textContent = "Row detail content for row " + rowIndex;
     *   return detail;
     * };
     *```
     *
     * @property {function} rowDetailsGenerator
     * @type {function}
     */
    set rowDetailsGenerator(rowDetailsGenerator) {
      this._grid.setRowDetailsGenerator(rowDetailsGenerator);
    },
    /**
     * @private
     */
    get rowDetailsGenerator() {
      return this._grid.getRowDetailsGenerator();
    },

    /**
     * Shows or hides row details for the row at the given index.
     *
     * @method setRowDetailsVisible
     * @param {number} rowIndex
     * @param {boolean} visible
     */
    setRowDetailsVisible: function(rowIndex, visible) {
      this._grid.setRowDetailsVisible(rowIndex, visible);
    },

    /**
     * Clears the grid’s internal data cache, causing it to request the
     * visible items in the grid viewport from the `items` property or the
     * `datasource` function, and to scroll back to the top of the grid viewport.
     *
     * Needs to be called whenever the data items are modified in some way
     * (added, removed, updated, re-ordered etc.).
     *
     * @type {Function}
     */
    refreshItems: function() {
      this._grid.getDataSource().refreshItems();
    },

    /**
     * Invokes the callback with row data of the provided row index as the
     * parameter. If the row is not cached, it's fetched from the data source
     * first.
     *
     * @method getItem
     * @param {number} rowIndex - Index of the row.
     * @param {Function} callback - Gets arguments (err, item) where item is the desired data item.
     * @param {boolean} onlyCached - Only fetch cached rows (don't fall back to data source request).
     */
    getItem: function(rowIndex, callback, onlyCached) {
      this._grid.getItem(rowIndex, callback, onlyCached);
    }
  }); // End Polymer prototype
</script>
